import { Input, SchemaBlueprint, SchemaRules, SchemaDefinition, TypeMapping } from '../models/SchemaTypes';
import { FailedValidation, SuccessfulValidation } from '../models/ValidationResults';
export declare class Schema<T extends SchemaDefinition> implements SchemaBlueprint<T> {
    private readonly schema;
    private readonly rules;
    constructor(schema: T, rules?: SchemaRules);
    check(input: Input<T>): FailedValidation | SuccessfulValidation<{
        [K in keyof T]: TypeMapping[T[K]];
    }>;
    private isOfType;
    length(): number;
}
