import { FailedValidation, SuccessfulValidation } from './ValidationResults';
export declare type SupportedTypes = 'string' | 'number' | 'boolean' | 'object' | 'array' | 'any';
export declare type TypeMapping = {
    string: string;
    number: number;
    boolean: boolean;
    object: Record<string, unknown>;
    array: any[];
    any: any;
};
export declare type SchemaDefinition = {
    [key: string]: keyof TypeMapping;
};
export declare type Input<T extends SchemaDefinition> = {
    [K in keyof T]: TypeMapping[T[K]];
};
export declare type SchemaBlueprint<T extends SchemaDefinition> = {
    check(value: Input<T>): FailedValidation | SuccessfulValidation<{
        [K in keyof T]: TypeMapping[T[K]];
    }>;
    length(): number;
};
export declare type SchemaRules = {
    excess?: {
        allow?: boolean;
        noClean?: boolean;
    };
};
