export interface SuccessfulValidation<T = any> {
    success: true;
    value: T;
}
declare type TypeOfFailure = 'WRONG_TYPE' | 'MISSING_KEYS' | 'EXCESS_KEYS' | 'INTERNAL_ERROR';
export interface FailedValidation {
    success: false;
    type: TypeOfFailure;
}
export declare const VALID_INPUT: <T>(value: T) => SuccessfulValidation<T>;
export declare const INVALID_INPUT: (type: TypeOfFailure) => FailedValidation;
export declare const WRONG_TYPE_INPUT: () => FailedValidation;
export declare const MISSING_KEYS_INPUT: () => FailedValidation;
export declare const EXCESS_KEYS_INPUT: () => FailedValidation;
export declare const INTERNAL_ERROR: () => FailedValidation;
export {};
